"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _Leaflet = require("./Leaflet");

var _Leaflet2 = _interopRequireDefault(_Leaflet);

var _typesLatlng = require("./types/latlng");

var _typesLatlng2 = _interopRequireDefault(_typesLatlng);

var _PopupContainer2 = require("./PopupContainer");

var _PopupContainer3 = _interopRequireDefault(_PopupContainer2);

var Circle = (function (_PopupContainer) {
  _inherits(Circle, _PopupContainer);

  function Circle() {
    _classCallCheck(this, Circle);

    _get(Object.getPrototypeOf(Circle.prototype), "constructor", this).apply(this, arguments);
  }

  _createClass(Circle, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      _get(Object.getPrototypeOf(Circle.prototype), "componentWillMount", this).call(this);
      var _props = this.props;
      var center = _props.center;
      var map = _props.map;
      var radius = _props.radius;
      var editable = _props.editable;
      var color = _props.color;
      var weight = _props.weight;
      var opacity = _props.opacity;

      var props = _objectWithoutProperties(_props, ["center", "map", "radius", "editable", "color", "weight", "opacity"]);

      this.leafletElement = _Leaflet2["default"].circle(center, radius, props);
      if (editable) this.leafletElement.editing.enable();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _props2 = this.props;
      var center = _props2.center;
      var map = _props2.map;
      var radius = _props2.radius;
      var editable = _props2.editable;
      var color = _props2.color;
      var weight = _props2.weight;
      var opacity = _props2.opacity;

      var props = _objectWithoutProperties(_props2, ["center", "map", "radius", "editable", "color", "weight", "opacity"]);

      if (center !== prevProps.center) {
        this.leafletElement.setLatLng(center);
      }
      if (radius !== prevProps.radius) {
        this.leafletElement.setRadius(radius);
      }

      if (editable !== prevProps.editable) {
        editable ? this.leafletElement.editing.enable() : this.leafletElement.editing.disable();
      }
      if (color !== prevProps.color) this.leafletElement.setStyle({ color: color });
      if (weight !== prevProps.weight) this.leafletElement.setStyle({ weight: weight });
      if (opacity !== prevProps.opacity) this.leafletElement.setStyle({ opacity: opacity });
    }
  }]);

  return Circle;
})(_PopupContainer3["default"]);

exports["default"] = Circle;

Circle.propTypes = {
  center: _typesLatlng2["default"].isRequired,
  radius: _react2["default"].PropTypes.number.isRequired
};
module.exports = exports["default"];