"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactDom = require("react-dom");

var _reactDom2 = _interopRequireDefault(_reactDom);

var _Leaflet = require("./Leaflet");

var _Leaflet2 = _interopRequireDefault(_Leaflet);

var _MapComponent2 = require("./MapComponent");

var _MapComponent3 = _interopRequireDefault(_MapComponent2);

var ControlLayer = (function (_MapComponent) {
  _inherits(ControlLayer, _MapComponent);

  function ControlLayer() {
    _classCallCheck(this, ControlLayer);

    _get(Object.getPrototypeOf(ControlLayer.prototype), "constructor", this).apply(this, arguments);
  }

  _createClass(ControlLayer, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this = this;

      _get(Object.getPrototypeOf(ControlLayer.prototype), "componentDidMount", this).call(this);
      this.controls = [];

      _react2["default"].Children.forEach(this.props.children, function (child) {
        var control = new Control({ component: child });
        _this.props.map.addControl(control);
        _this.controls.push(control);
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this2 = this;

      _get(Object.getPrototypeOf(ControlLayer.prototype), "componentWillUnmount", this).call(this);

      this.controls.forEach(function (control) {
        _this2.props.map.removeControl(control);
      });
    }
  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }]);

  return ControlLayer;
})(_MapComponent3["default"]);

exports["default"] = ControlLayer;

var Control = _Leaflet2["default"].Control.extend({

  initialize: function initialize(options) {
    this.component = options.component;
    this.options.position = this.component.props.position;
  },

  onAdd: function onAdd(map) {
    this.container = _Leaflet2["default"].DomUtil.create('div', 'zoom-map-control');
    var el = _react2["default"].cloneElement(this.component, { map: map });
    _reactDom2["default"].render(el, this.container);
    return this.container;
  },

  onRemove: function onRemove(map) {
    _react2["default"].unmountComponentAtNode(this.container);
  }

});
module.exports = exports["default"];