"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _Leaflet = require("./Leaflet");

var _Leaflet2 = _interopRequireDefault(_Leaflet);

var _lodash = require("lodash");

var _lodash2 = _interopRequireDefault(_lodash);

var _typesLatlng = require("./types/latlng");

var _typesLatlng2 = _interopRequireDefault(_typesLatlng);

var _PopupContainer2 = require("./PopupContainer");

var _PopupContainer3 = _interopRequireDefault(_PopupContainer2);

var Marker = (function (_PopupContainer) {
  _inherits(Marker, _PopupContainer);

  function Marker() {
    _classCallCheck(this, Marker);

    _get(Object.getPrototypeOf(Marker.prototype), "constructor", this).apply(this, arguments);
  }

  _createClass(Marker, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      _get(Object.getPrototypeOf(Marker.prototype), "componentWillMount", this).call(this);
      var _props = this.props;
      var map = _props.map;
      var position = _props.position;

      var props = _objectWithoutProperties(_props, ["map", "position"]);

      this.leafletElement = _Leaflet2["default"].marker(position, props);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      _get(Object.getPrototypeOf(Marker.prototype), "componentDidMount", this).call(this);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _props2 = this.props;
      var position = _props2.position;
      var icon = _props2.icon;
      var zIndexOffset = _props2.zIndexOffset;
      var opacity = _props2.opacity;
      var draggable = _props2.draggable;
      var contextmenu = _props2.contextmenu;
      var contextmenuInheritItems = _props2.contextmenuInheritItems;
      var contextmenuItems = _props2.contextmenuItems;

      this.leafletElement.unbindContextMenu();
      var options = { contextmenu: contextmenu, contextmenuInheritItems: contextmenuInheritItems, contextmenuItems: contextmenuItems };
      this.leafletElement.bindContextMenu(options);

      if (!_lodash2["default"].isEqual(position, prevProps.position)) {
        this.leafletElement.setLatLng(position);
      }
      if (!_lodash2["default"].isEqual(icon, prevProps.icon)) {
        draggable ? this.leafletElement.dragging.enable() : this.leafletElement.dragging.disable();
        this.leafletElement.setIcon(icon);
      }
      if (zIndexOffset !== prevProps.zIndexOffset) {
        this.leafletElement.setZIndexOffset(zIndexOffset);
      }
      if (opacity !== prevProps.opacity) {
        this.leafletElement.setOpacity(opacity);
      }
      if (draggable !== prevProps.draggable) {
        draggable ? this.leafletElement.dragging.enable() : this.leafletElement.dragging.disable();
      }
    }
  }]);

  return Marker;
})(_PopupContainer3["default"]);

exports["default"] = Marker;

Marker.propTypes = {
  position: _typesLatlng2["default"].isRequired
};
module.exports = exports["default"];