"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _Leaflet = require("./Leaflet");

var _Leaflet2 = _interopRequireDefault(_Leaflet);

var _leafletDraw = require("leaflet-draw");

var _leafletDraw2 = _interopRequireDefault(_leafletDraw);

var _lodash = require("lodash");

var _lodash2 = _interopRequireDefault(_lodash);

var _typesLatlngList = require("./types/latlngList");

var _typesLatlngList2 = _interopRequireDefault(_typesLatlngList);

var _PopupContainer2 = require("./PopupContainer");

var _PopupContainer3 = _interopRequireDefault(_PopupContainer2);

var Polyline = (function (_PopupContainer) {
  _inherits(Polyline, _PopupContainer);

  function Polyline() {
    _classCallCheck(this, Polyline);

    _get(Object.getPrototypeOf(Polyline.prototype), "constructor", this).apply(this, arguments);
  }

  _createClass(Polyline, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      _get(Object.getPrototypeOf(Polyline.prototype), "componentWillMount", this).call(this);
      var _props = this.props;
      var map = _props.map;
      var positions = _props.positions;

      var props = _objectWithoutProperties(_props, ["map", "positions"]);

      this.leafletElement = _Leaflet2["default"].polyline(positions, props);
      if (this.props.editable) this.leafletElement.editing.enable();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _props2 = this.props;
      var positions = _props2.positions;
      var editable = _props2.editable;
      var color = _props2.color;
      var weight = _props2.weight;
      var opacity = _props2.opacity;
      var contextmenu = _props2.contextmenu;
      var contextmenuInheritItems = _props2.contextmenuInheritItems;
      var contextmenuItems = _props2.contextmenuItems;

      this.leafletElement.unbindContextMenu();
      var options = { contextmenu: contextmenu, contextmenuInheritItems: contextmenuInheritItems, contextmenuItems: contextmenuItems };
      this.leafletElement.bindContextMenu(options);

      if (!_lodash2["default"].isEqual(positions, prevProps.positions)) {
        this.leafletElement.setLatLngs(positions);
        if (editable === prevProps.editable && editable) {
          this.leafletElement.editing.disable();
          this.leafletElement.editing.enable();
        }
      }
      if (editable !== prevProps.editable) {
        editable ? this.leafletElement.editing.enable() : this.leafletElement.editing.disable();
      }
      if (color !== prevProps.color) this.leafletElement.setStyle({ color: color });
      if (weight !== prevProps.weight) this.leafletElement.setStyle({ weight: weight });
      if (opacity !== prevProps.opacity) this.leafletElement.setStyle({ opacity: opacity });
    }
  }]);

  return Polyline;
})(_PopupContainer3["default"]);

exports["default"] = Polyline;

Polyline.propTypes = {
  positions: _typesLatlngList2["default"].isRequired
};
module.exports = exports["default"];